#include "testApp.h"

//--------------------------------------------------------------
void testApp::setup(){
	
	// set background color to be white: 
	ofBackground(255, 255, 255);
	
	// this prevents banding on mac (vertical sync)
	ofSetVerticalSync(true);
	
	
	// load the image from the data folder
	myPicture.loadImage("test.png");
	
	// set the image type to be grayscale (1 byte per pixel)
	myPicture.setImageType(OF_IMAGE_GRAYSCALE);
	
	// allocate pixels and texture for this image. 
	width			= myPicture.width;
	height			= myPicture.height;
	pixels			= new unsigned char [width * height];
	texture.allocate(width, height, GL_LUMINANCE);
	
	// we need a place to blur into  (can't blur *in place*)
	pixelsBlurred	= new unsigned char [width * height];
	
	
	
	
	// get a pointer to the image data:
	unsigned char * pixelsFromImage = myPicture.getPixels();
	
	// copy the pixels in...
	for (int i = 0; i < width; i++){
		for (int j = 0; j < height; j++){
			int pixIndex = j * width + i;
			pixels[pixIndex]  = pixelsFromImage[pixIndex];
		}
	}
	
	
	// now, let's blur from pixels into pixelsBlurred:
	for (int i = 0; i < width; i++){
		for (int j = 0; j < height; j++){
			
			// not accounting for edges. 
			/*
			int nw = ((j-1) * width + (i-1));
			int n_ = ((j-1) * width + (i  ));
			int ne = ((j-1) * width + (i+1));
			int _w = ((j  ) * width + (i-1));
			int me = ((j  ) * width + (i  ));
			int _e = ((j  ) * width + (i+1));
			int sw = ((j+1) * width + (i-1));
			int s_ = ((j+1) * width + (i  ));
			int se = ((j+1) * width + (i+1));
			*/
			
			// deal with the edges !! :
			
			int pixIndex = j * width + i;
			
			int i_m_1 = MAX(0, i-1);
			int i_p_1 = MIN(width-1, i+1);
			int j_m_1 = MAX(0, j-1);
			int j_p_1 = MIN(height-1, j+1);
			
			int nw = (j_m_1 * width + i_m_1);
			int n_ = (j_m_1 * width + i    );
			int ne = (j_m_1 * width + i_p_1);
			int _w = (j     * width + i_m_1);
			int me = (j     * width + i    );
			int _e = (j     * width + i_p_1);
			int sw = (j_p_1 * width + i_m_1);
			int s_ = (j_p_1 * width + i    );
			int se = (j_p_1 * width + i_p_1);
			
			int newValue =	pixels[ne] + pixels[n_] + pixels[nw] + pixels[_e] + pixels[me] + pixels[_w] + 
							pixels[se] + pixels[s_] + pixels[sw];
			
			newValue /= 9;
			
			pixelsBlurred[pixIndex]  = newValue;
		}
	}
	
	
	
	
	texture.loadData(pixelsBlurred, width, height, GL_LUMINANCE);
	
		
}

//--------------------------------------------------------------
void testApp::update(){
	
	
		
	
}

//--------------------------------------------------------------
void testApp::draw(){
	

	// when we draw, the drawing color "tints" the drawing, so white is best for image
	// ie, white = no tint.
	ofSetColor(255, 255, 255);
	myPicture.draw(0,0);
	
	texture.draw(myPicture.width, 0);
	
}

//--------------------------------------------------------------
void testApp::keyPressed(int key){

}

//--------------------------------------------------------------
void testApp::keyReleased(int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}

